package server

import (
	"github.com/miscreant/miscreant/go"
	"golang.org/x/crypto/scrypt"
)

func decrypt(data, pw []byte) ([]byte, error) {
	// Apply the key derivation function to the password to obtain
	// a 64 byte key.
	dk, err := scrypt.Key(pw, nil, 16384, 1, 8, 64)
	if err != nil {
		return nil, err
	}

	// Set up the AES-SIV secret box.
	cipher, err := miscreant.NewAESCMACSIV(dk)
	if err != nil {
		return nil, err
	}

	return cipher.Open(nil, data)
}
